<template>
    <div class="s">
        <div class="t">
            <chatCard v-for="(item, index) in items" :key="index" v-bind="item" />
            <div id="anchor"></div>
            <Emoji @click="selectedEmoji" v-if="showEmojis" />
        </div>
        <el-card>
            <div class="rightcont">
                <v-btn-toggle dense>
                    <v-btn @click="Emoji" class="face"><v-icon>mdi-sticker-emoji</v-icon></v-btn>
                </v-btn-toggle>
                <!-- <v-btn color="thirdary" class="white--text" @click="send">发送</v-btn> -->
                <el-button type="primary" class="white--text" @click="send">发送</el-button>
            </div>
            <v-divider></v-divider>
            <v-textarea
                clearable
                v-model="mydata.message"
                class="pl-2 mt-0"
                dense
                color="secondary"
                :error="sendAlert"
                :error-messages="errorMessage"
            ></v-textarea>
        </el-card>
    </div>
</template>

<!--the js for jquery.mCustomScrollbar-->
<script src="../../../node_modules/jquery-emoji/lib/script/jquery.mCustomScrollbar.min.js"></script>
<!--the js for this plugin-->
<script src="../../../node_modules/jquery-emoji/js/jquery.emoji.js"></script>
<script>
import chatCard from "./chatCard";
// import io from "socket.io-client";
import { VueChatEmoji, emojis } from "vue-chat-emoji";

export default {
    name: "conversation",
    components: {
        chatCard,
        Emoji: VueChatEmoji,
    },
    data: () => ({
        items: [],
        mydata: {
            userId: 4,
            nickName: "",
            userName: "",
            avatar: "",
            color: "",
            message: ``,
            projectName: "",
        },
        errorMessage: "",
        sendAlert: false,
        showEmojis: false,
        roomId: 0,
    }),
    methods: {
        send() {
            if (!this.mydata.message.length) {
                this.send_alert("无法发送空信息！");
                return;
            }

            // 获取到聊天的内容
            const content = {
                nickName: this.mydata.nickName,
                userName: this.mydata.userName,
                avatar: this.mydata.avatar,
                color: this.mydata.color,
                message: this.mydata.message,
                mine: true,
                roomId: this.roomId,
            };

            console.log("CodeChat.SendMessage", content);

            // 发送给服务器
            this.$evtbus.$emit("CodeChat.SendMessage", content);
            this.mydata.message = ``;
        },
        send_alert(message) {
            this.sendAlert = true;
            this.errorMessage = "" + message;
        },
        Scroll() {
            const a = document.getElementById("anchor");
            a.scrollIntoView();
        },
        Emoji() {
            this.showEmojis = !this.showEmojis;
            setTimeout(this.Scroll, 200);
        },
        selectedEmoji(args) {
            //console.log(args);
            if(this.mydata.message!=null){
                this.mydata.message += args.emoji;
            }
            else{
                this.mydata.message = args.emoji;
            }
        },
    },
    mounted() {
        this.mydata.userName = this.$store.getters.userName;
        this.mydata.nickName = this.$store.getters.nickName;
        this.mydata.avatar = this.$store.getters.userAvatar;
        this.mydata.color = this.$store.getters.userColor;
        console.log(this.mydata);

        const self = this;

        // todo: 先把joinroom逻辑放在这里
        // this.$evtbus.$emit("CodeEdit.JoinRoom", {
        //     userId: self.mydata.userId,
        //     userName: self.mydata.userName,
        //     room: self.mydata.projectName,
        // });

        this.$evtbus.$on("CodeChat.ReceiveMessage", data => {
            if (data.roomId !== self.roomId) {
                return;
            }

            if (data.userName !== self.mydata.userName) data.mine = false;
            self.items.push(data);
            setTimeout(self.Scroll, 200);
        });

        this.$evtbus.$on("CodeEdit.RoomHasChanged", roomId => {
            self.roomId = roomId;
        });

        this.$evtbus.$on("CodeEdit.ClearChat", () => {
            self.items = [];
        });
    },
    sockets: {
        // connect() {
        //     this.id = this.$socket.id;
        //     console.log("socketId: ", this.$socket.id);
        //     this.$socket.emit("login", this.mydata.userName); //监听connect事件
        // },
    },
    computed: {},
};
</script>

<!--the css for jquery.mCustomScrollbar-->
<style href="lib/css/jquery.mCustomScrollbar.min.css"></style>
<style href="css/jquery.emoji.css"></style>
<style scoped>
.s {
    margin-top: 50px;
    height: calc(100vh - 40px);
    /* background-color: #ae55ee; */
    background-color: #66a3d2;
}
.t {
    overflow-y: auto;
    overflow-x: hidden;
    height: calc(100vh - 83px - 194px);
}
.rightcont {
    display: flex;
    justify-content: flex-end;
}
</style>
